/* remove comments from .OBJ file */

#include <tt.h>

char program_name[] = "RCO";

#define THEADR 0x80
#define COMENT 0x88
#define MODEND 0x8A

#define ls_byte(x)  ((unsigned char *)(&(x)))[0]
#define ms_byte(x)  ((unsigned char *)(&(x)))[1]

static char HELP[] = "\r\n"
  "RCO   source-file   destination-file   [name]\r\n"
  "\r\n"
  "This utility removes the comment records from the source file (which\r\n"
  "must be an .OBJ file) and writes the result to the destination file.\r\n"
  "If the third argument is present, it is used as the new module name\r\n"
  "in the header.\r\n";

static jump_buffer read_error, write_error;

void main()
{
  FILE *source, *destination;
  if (jumped(read_error))
  {
    error_exit("Source file not in .OBJ format");
  }
  if (jumped(write_error)) error_exit("File write error");
  if (command_line_argument(2)==NULL)
  {
    standard_output_string(HELP);
    exit(1);
  }
  source = fopen(command_line_argument(1), FALSE, 2048, read_error,
    read_error);
  if (source==NULL) error_exit("Can't open source file");
  destination = fopen(command_line_argument(2), TRUE, 2048, write_error,
    write_error);
  if (destination==NULL) error_exit("Can't open destination file");
  while (TRUE)
  {
    int type = getc(source);
    unsigned length;
    ls_byte(length) = getc(source);
    ms_byte(length) = getc(source);
    if (type==THEADR && command_line_argument(3)!=NULL)
    {
      int checksum = THEADR;
      char *t = command_line_argument(3);
      while (length-- != 0) getc(source);
      length = string_length(t) + 2;
      checksum += length + (length>>8) + length - 2;
      putc(THEADR, destination);
      putc(length, destination);
      putc(ms_byte(length), destination);
      putc(length-2, destination);
      while (*t!=0) {putc(*t, destination); checksum += *t++;}
      putc(-checksum, destination);
    }
    else
    {
      if (type != COMENT)
      {
        putc(type, destination);
        putc(length, destination);
        putc(ms_byte(length), destination);
      }
      while (length-- != 0)
      {
        int c = getc(source);
        if (type != COMENT) putc(c, destination);
      }
      if (type==MODEND) break;
    }
  }
  fclose(source);
  fclose(destination);
}
